Subject: Re: [RFC] bridge and friends: reduce TheLinuxWay(tm)

From: Jamal Hadi Salim <[email-masked]>
Date: Wed, 16 Oct 2013 09:54:57 -0400

On 10/14/13 17:41, Stephen Hemminger wrote:

> Unfortunately, by now this is all set in ABI.
> It was a side effect of the per-feature evolutionary style of development.

Sadly, I agree. This is the dark side of "have code will travel";
you let these things out in the wild, they breed and you cant
take them back.
BTW: I dont think what i suggested will be a harmful refactoring because
no existing interfaces are removed - your call.

In similar vein:
What is the motivation behind IFLA_EXT_MASK? Could you not have used
ifm ifindex to relay the interface of interest? Currently the ifindex is
not used at all. IMO, the following interfaces are useful:
- get attributes for all bridge ports (this is there)
- get attributes for bridge interface XXX; there using IFLA_EXT_MASK
I think it should be using ifm->ifindex
- get attributes for all bridge ports for bridge br-blah (not there)
you could also use the ifindex of br-blah here instead

Separate issue:
To provide equivalence to brctl:
- PF_BRIDGE should allow me to attach a bridge port to bridge of choice
with SETLINK

cheers,
jamal